select
  an.numero
  , (select grausangue from sp_calculagrausangue(an.cdanimal)) as raca
  , se.nome as setor
  , g1.descricao as grupo
  , ultpar.data as ultimo_parto
  , (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7) +
            coalesce(an.numpartoentrada, 0) as ordem_parto
  , ultexa.data as ultimo_exame_ginecologico
  , oe.nomeresumido as oe
  , od.nomeresumido as od
  , ut.nomeresumido as ut
  , (case when (ultcio.cdreproducao is not null) then (current_date - ultcio.data) else null end) as dias_apos_ult_cio
  , maxlei.pesototal as ultimo_contr_leiteiro
  , (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data < ultpar.data
        and re.data > coalesce(parant.data, '1900-01-01')) as num_tent_ult_parto
  , apli.dtaplicacaoproduto as data_ult_aplicacao
  , pr.nome as ult_produto_aplicado
  , pa.nome as base_recomendada_ult_exa
from
  animal an
  join setor se on se.cdsetor = an.cdsetor
   left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = an.cdanimal and re.cdtipogrupoanimal = 5 and re.dtmovimentacao <= current_date order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7
        order by re.data desc)
  left join reproducao ultexa on ultexa.cdreproducao =
     (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and ((re.cdresultadoexameut is not null)
                or (re.cdresultadoexameoe is not null) or (re.cdresultadoexameod is not null)) and re.data > coalesce(ultpar.data, '1900-01-01')
                order by re.data desc)
  left join resultadoexameginecologico oe on oe.cdresultadoexameginecologico = ultexa.cdresultadoexameoe
  left join resultadoexameginecologico od on od.cdresultadoexameginecologico = ultexa.cdresultadoexameod
  left join resultadoexameginecologico ut on ut.cdresultadoexameginecologico = ultexa.cdresultadoexameut
  left join reproducao ultcio on ultcio.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cio in (1,2) and re.data >
        coalesce(ultpar.data, '1900-01-01') order by re.data desc)
  left join leite maxlei on maxlei.cdleite =
    (select first 1 re.cdleite from leite re where re.cdanimal = an.cdanimal and re.dtleite > ultpar.data
        order by re.dtleite desc)
  left join reproducao parant on parant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ultpar.cdanimal and re.data < ultpar.data and re.cdtiporeproducao = 7
        order by re.data desc)
  left join aplicacaoproduto apli on apli.cdaplicacaoproduto =
    (select first 1 re.cdaplicacaoproduto from aplicacaoproduto re where re.cdanimal = an.cdanimal order by re.dtaplicacaoproduto desc)
  left join produto pr on pr.cdproduto = apli.cdproduto
  left join principioativo pa on pa.cdprincipioativo = ultexa.cdprincipioativo
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null
  and an.cdcategoria in (6,7)
